Package org.jboss.logmanager

# Class NDC

java.lang.Object
org.jboss.logmanager.NDC

public final class NDC extends Object
Nested diagnostic context. This is basically a thread-local stack that holds a string which can be included in a log message.

## Method Summary

Modifier and Type
Method
Description
`static void`
`clear()`
Clear the thread's NDC stack.
`static String`
`get()`
Get the current NDC value.
`static String`
`get(int n)`
Provided for compatibility with log4j.
`static int`
`getDepth()`
Get the current NDC stack depth.
`static String`
`pop()`
Pop the topmost value from the NDC stack and return it.
`static int`
`push(String context)`
Push a value on to the NDC stack, returning the new stack depth which should later be used to restore the stack.
`static void`
`trimTo(int size)`
Trim the thread NDC stack down to no larger than the given size.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### push

public static int push(String context)
Push a value on to the NDC stack, returning the new stack depth which should later be used to restore the stack.

Parameters:
  `context` - the new value
Returns:
  the new stack depth

### pop

public static String pop()
Pop the topmost value from the NDC stack and return it.

Returns:
  the old topmost value

### clear

public static void clear()
Clear the thread's NDC stack.

### trimTo

public static void trimTo(int size)
Trim the thread NDC stack down to no larger than the given size. Used to restore the stack to the depth returned by a `push()`.

Parameters:
  `size` - the new size

### getDepth

public static int getDepth()
Get the current NDC stack depth.

Returns:
  the stack depth

### get

public static String get()
Get the current NDC value.

Returns:
  the current NDC value, or `""` if there is none

### get

public static String get(int n)
Provided for compatibility with log4j. Get the NDC value that is `n` entries from the bottom.

Parameters:
  `n` - the index
Returns:
  the value or `null` if there is none